# {{ ansible_managed }}
#
# See the sshd_config(5) manpage for details

# What ports, IPs and protocols we listen for
Port 22

{% if aehostd_sshd_listen_addresses %}
# Restrict which interfaces/protocols sshd will bind to
{% for listen_addess in aehostd_sshd_listen_addresses %}
ListenAddress {{ listen_addess }}
{% endfor %}
{% endif %}

Protocol 2
# HostKeys for protocol version 2
HostKey /etc/ssh/ssh_host_rsa_key
HostKey /etc/ssh/ssh_host_dsa_key
HostKey /etc/ssh/ssh_host_ecdsa_key
#HostKey /etc/ssh/ssh_host_ed25519_key

# Logging
SyslogFacility AUTH
LogLevel {{ aehostd_sshd_loglevel }}

#---------------------------------------------------------------------------
# Authentication
#---------------------------------------------------------------------------

# this must be set to yes, otherwise aehost-init does not work
UsePAM yes

LoginGraceTime 120
PermitRootLogin yes
StrictModes yes

# disable all unwanted authentication methods
#---------------------------------------------------------------------------
KerberosAuthentication no
GSSAPIAuthentication no
ChallengeResponseAuthentication no
PasswordAuthentication no
PermitEmptyPasswords no
HostbasedAuthentication no
IgnoreRhosts yes
IgnoreUserKnownHosts yes

# authentication based on authorized keys
#---------------------------------------------------------------------------
PubkeyAuthentication yes
AuthenticationMethods publickey
# find pre-installed SSH keys in fixed location for
# - separately configured services
# - root's emergency keys
AuthorizedKeysFile {{ aehostd_sshd_authorized_keys }}/%u
# retrieve SSH keys loaded from AE-DIR from separate location
# with different ownership
AuthorizedKeysCommand /bin/cat '{{ aehostd_sshkeys_dir }}/%u'
AuthorizedKeysCommandUser {{ aehostd_user }}

{% if aehostd_sshd_trusted_userca_keys %}
# authentication based on OpenSSH user certificates
#---------------------------------------------------------------------------
# File name of public keys trusted for signing user certs
TrustedUserCAKeys {{ aehostd_sshd_trusted_userca_keys }}
{% endif %}

X11Forwarding no
X11DisplayOffset 10
PrintMotd no
PrintLastLog yes
TCPKeepAlive yes

#MaxStartups 10:30:60
#Banner /etc/issue.net

# Allow client to pass locale environment variables
AcceptEnv LANG LC_*

{% if aehostd_sshd_sftp_server %}
# SFTP server to use
Subsystem sftp {{ aehostd_sshd_sftp_server }}
{% endif %}

#---------------------------------------------------------------------------
# specific subconfigurations limited by Match directive
#---------------------------------------------------------------------------

# for aehostd's password initialization via PAM pseudo login
# authentication is limited to password authentication
Match User aehost-init
    PubkeyAuthentication no
    PasswordAuthentication yes
    AuthenticationMethods password
